## neovim-qt 0.2.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)
if (POLICY CMP0069)
  cmake_policy(SET CMP0069 NEW)
endif (POLICY CMP0069)

# Neovim-Qt Version, used by --version update before release
# 9999 = Development Pre-Release
project(neovim-qt VERSION 0.2.18.0)

if(NOT EXISTS ${NEOVIM_EXEC})
	set(NEOVIM_EXEC nvim)
endif()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

option(USE_GCOV "Enable gcov support" OFF)
option(ENABLE_CLAZY "Build with KDE Clang Clazy Linter" OFF)
option(ENABLE_TIDY "Build with Clang Tidy Linter" OFF)

if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR
		"${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -Wno-unused-parameter -Wunused-variable")

	# Qt Static Analysis - Clang-Tidy based extension
	if(ENABLE_CLAZY)
		string(CONCAT CLAZY_CHECKS
			"level0,"
			"level1,"
			"no-inefficient-qlist-soft,"
			)

		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Xclang -plugin-arg-clazy -Xclang ${CLAZY_CHECKS} -Wno-deprecated-declarations -Werror")
	endif()

	# Clang-Tidy Static Analysis
	if(ENABLE_TIDY)
		string(CONCAT TIDY_CHECKS
			"-*,"
			"bugprone-*,"
			"-bugprone-branch-clone,"
			"-bugprone-inaccurate-erase,"
			"-bugprone-narrowing-conversions,"
			"-bugprone-parent-virtual-call,"
			"-bugprone-suspicious-include,"
			"-bugprone-undefined-memory-manipulation,"
			"cppcoreguidelines-*,"
			"-cppcoreguidelines-avoid-c-arrays,"
			"-cppcoreguidelines-avoid-goto,"
			"-cppcoreguidelines-avoid-magic-numbers,"
			"-cppcoreguidelines-avoid-non-const-global-variables,"
			"-cppcoreguidelines-explicit-virtual-functions,"
			"-cppcoreguidelines-init-variables,"
			"-cppcoreguidelines-macro-usage,"
			"-cppcoreguidelines-narrowing-conversions,"
			"-cppcoreguidelines-non-private-member-variables-in-classes,"
			"-cppcoreguidelines-owning-memory,"
			"-cppcoreguidelines-pro-bounds-array-to-pointer-decay,"
			"-cppcoreguidelines-pro-bounds-pointer-arithmetic,"
			"-cppcoreguidelines-pro-type-cstyle-cast,"
			"-cppcoreguidelines-pro-type-member-init,"
			"-cppcoreguidelines-pro-type-static-cast-downcast,"
			"-cppcoreguidelines-pro-type-vararg,"
			"-cppcoreguidelines-special-member-functions,"
			"modernize-*,"
			"-modernize-avoid-c-arrays,"
			"-modernize-loop-convert,"
			"-modernize-pass-by-value,"
			"-modernize-raw-string-literal,"
			"-modernize-return-braced-init-list,"
			"-modernize-use-auto,"
			"-modernize-use-nullptr,"
			"-modernize-use-override,"
			"-modernize-use-trailing-return-type,"
			"-modernize-use-using,"
			"performance-*,"
			"-performance-no-automatic-move,"
			"-performance-unnecessary-copy-initialization,"
			"-performance-unnecessary-value-param,"
			"readability-*,"
			"-readability-braces-around-statements,"
			"-readability-braces-around-statements,"
			"-readability-container-size-empty,"
			"-readability-convert-member-functions-to-static,"
			"-readability-delete-null-pointer,"
			"-readability-else-after-return,"
			"-readability-function-cognitive-complexity,"
			"-readability-function-size,"
			"-readability-identifier-naming,"
			"-readability-implicit-bool-cast,"
			"-readability-implicit-bool-conversion,"
			"-readability-inconsistent-declaration-parameter-name,"
			"-readability-isolate-declaration,"
			"-readability-magic-numbers,"
			"-readability-make-member-function-const,"
			"-readability-named-parameter,"
			"-readability-qualified-auto,"
			"-readability-redundant-access-specifiers,"
			"-readability-redundant-control-flow,"
			"-readability-redundant-member-init,"
			"-readability-simplify-boolean-expr,"
			"-readability-static-accessed-through-instance,"
			"-readability-uppercase-literal-suffix,"
			"-readability-identifier-length,"
			"-bugprone-easily-swappable-parameters,"
			"-bugprone-implicit-widening-of-multiplication-result,"
			"-cppcoreguidelines-prefer-member-initializer,"
			"-bugprone-unhandled-exception-at-new,"
			"-readability-suspicious-call-argument,"
			)
		if(${CMAKE_VERSION} VERSION_LESS "3.6.0")
			message("ENABLE_TIDY requires CMake >= 3.6.0")
		else()
			set(CMAKE_CXX_CLANG_TIDY clang-tidy "-checks=${TIDY_CHECKS};-warnings-as-errors=*")
		endif()
	endif()

	# Code Coverage Report
	if(USE_GCOV)
		message(STATUS "Enabling coverage")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")
		set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} --coverage")
		set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} --coverage")
	endif()

endif()

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)

# to generate a compile_commands.json usable by ycm and other tooling
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# konsole_wcwidth.h
include_directories(third-party)

# homebrew/macrpots/fink etc.
include(MacOSXPaths)

# Qt
set(CMAKE_AUTOMOC ON)

# Build against Qt5 or Qt6
if(NOT DEFINED WITH_QT)
	set(WITH_QT Qt5)
elseif(NOT WITH_QT STREQUAL "Qt5" AND NOT WITH_QT STREQUAL "Qt6")
	message(WARNING "Unknown qt version, expecting (Qt5, Qt6), using ${WITH_QT}")
endif()

set(REQ_QT_MODULES Core Network Test Widgets)
find_package(QT NAMES ${WITH_QT} COMPONENTS ${REQ_QT_MODULES} REQUIRED)
if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL 6.0)
	# Qt6 uses SvgWidgets instead of Svg
	set(REQ_QT_MODULES ${REQ_QT_MODULES} SvgWidgets)
	set(CMAKE_CXX_STANDARD 17)
else()
	set(REQ_QT_MODULES ${REQ_QT_MODULES} Svg)
endif()
message(STATUS "Building against Qt${QT_VERSION_MAJOR}.${QT_VERSION_MINOR} ${REQ_QT_MODULES}")
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS ${REQ_QT_MODULES} REQUIRED)

if(Qt${QT_VERSION_MAJOR}Core_VERSION VERSION_LESS 5.8)
	message(FATAL_ERROR "Minimum supported Qt5 version is 5.8!")
endif()

# msgpack
option(USE_SYSTEM_MSGPACK "Use system msgpack libraries " OFF)
if(USE_SYSTEM_MSGPACK)
	find_package(Msgpack REQUIRED)
else()
	add_subdirectory(third-party)
endif()
include_directories(${MSGPACK_INCLUDE_DIRS})

if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
endif()

# Place targets in bin/ or lib/ for all build configurations
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
foreach(CFGNAME ${CMAKE_CONFIGURATION_TYPES})
  string(TOUPPER ${CFGNAME} CFGNAME)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/bin)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/lib)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CFGNAME} ${CMAKE_BINARY_DIR}/lib)
endforeach()

if(MSVC)
  # Allow use of deprecated function names in MSVC (read/write)
  add_definitions(-D_CRT_NONSTDC_NO_DEPRECATE)
endif()

add_subdirectory(src)
add_subdirectory(doc)

option(ENABLE_TESTS "Build tests" OFF)
if(ENABLE_TESTS)
	find_package(QT NAMES ${WITH_QT} COMPONENTS Test REQUIRED)
	enable_testing()
	add_subdirectory(test)
	add_subdirectory(src/gui/shellwidget/test)
endif()

# Bindings
find_package(PythonInterp)
if (PYTHONINTERP_FOUND)
	set(NVIM "nvim" CACHE STRING "Path to nvim executable")
	add_custom_target(bindings
		COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/bindings/generate_bindings.py ${NVIM} ${CMAKE_SOURCE_DIR}/src/auto
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
		COMMENT "Generating bindings"
		)

	add_custom_target(bindings-preview
		COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_SOURCE_DIR}/bindings/generate_bindings.py ${NVIM}
		)
endif()

include(CPackOptions)

=== test/CMakeLists.txt ===
set(QTLIBS Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Svg Qt${QT_VERSION_MAJOR}::Test)
set(QTLIBS_GUI Qt${QT_VERSION_MAJOR}::Widgets)
set(QTLIBS_TEST Qt${QT_VERSION_MAJOR}::Test)

include_directories(${CMAKE_SOURCE_DIR}/src)
add_definitions(-DCMAKE_SOURCE_DIR=\"${CMAKE_SOURCE_DIR}\")
add_definitions(-DNVIM_QT_BINARY=\"$<TARGET_FILE:nvim-qt>\")
if (WIN32 AND USE_STATIC_QT)
	add_definitions(-DUSE_STATIC_QT)
endif ()

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

# Place all platform-specific test definitions here
if(WIN32)
	set(SRC_SHELL_PLATFORM tst_shell_win32.cpp)
elseif(APPLE)
	set(SRC_SHELL_PLATFORM tst_shell_mac.cpp)
else()
	set(SRC_SHELL_PLATFORM tst_shell_unix.cpp)
endif()

set(SOURCES_COMMON common.cpp)
set(SOURCES_COMMON_GUI common_gui.cpp)

function(add_xtest SOURCE_NAME)
	add_executable(${SOURCE_NAME}
		${SOURCE_NAME}.cpp
		${SOURCES_COMMON}
		${ARGV1}
		${ARGV2})
	target_link_libraries(${SOURCE_NAME} ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME} ${CTEST_EXE_ARGS})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

function(add_xtest_gui SOURCE_NAME)
	if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL 6)
		qt_add_resources(RCC_SOURCES data.qrc)
	else()
		qt5_add_resources(RCC_SOURCES data.qrc)
	endif()
	add_executable(${SOURCE_NAME}
		${RCC_SOURCES}
		${SOURCE_NAME}.cpp
		${SOURCES_COMMON}
		${SOURCES_COMMON_GUI}
		${ARGV1} ${ARGV2})
	target_link_libraries(${SOURCE_NAME} ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt Qt${QT_VERSION_MAJOR}::Widgets neovim-qt-gui)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME} ${CTEST_EXE_ARGS}
		# Run GUI tests from source dir, they depend on src files
		WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

function(add_shared_test SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${ARGV1} ${ARGV2} ${ARGV3})
	target_link_libraries(${SOURCE_NAME} Qt${QT_VERSION_MAJOR}::Network ${QTLIBS_TEST} ${QTLIBS_GUI} ${MSGPACK_LIBRARIES} neovim-qt)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME})
	add_dependencies(check ${SOURCE_NAME})
endfunction()

add_xtest(tst_neovimobject)
add_xtest(tst_neovimconnector)
add_xtest(tst_callallmethods)
add_xtest(tst_encoding)
add_xtest(tst_msgpackiodevice)
add_xtest_gui(tst_shell ${SRC_SHELL_PLATFORM})
add_xtest_gui(tst_main)
add_xtest_gui(tst_qsettings
	${SRC_SHELL_PLATFORM}
	mock_qsettings.cpp)

# Platform Specific Input Tests
add_xtest(tst_input_mac
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_mac.cpp)
add_xtest(tst_input_unix
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_unix.cpp)
add_xtest(tst_input_win32
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_win32.cpp)

# Platform Agnostic Input Tests
add_shared_test(tst_input_common_mac
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_mac.cpp)
add_shared_test(tst_input_common_unix
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_unix.cpp)
add_shared_test(tst_input_common_win32
	tst_input_common.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input.cpp
	${CMAKE_SOURCE_DIR}/src/gui/input_win32.cpp)

=== third-party/CMakeLists.txt ===
# This is a minimal CMake project to fetch and build third party
# dependencies
cmake_minimum_required(VERSION 2.8.12)
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)
project(neovim-qt-deps)

#
# Get Msgpack
#
set(MSGPACK_VERSION 3.2.0)
set(MSGPACK_URL https://github.com/msgpack/msgpack-c/archive/cpp-${MSGPACK_VERSION}.tar.gz)
set(MSGPACK_SHA256 ff865a36bad5c72b8e7ebc4b7cf5f27a820fce4faff9c571c1791e3728355a39)

message(STATUS "Downloading Msgpack...")
set(MSGPACK_TARBALL msgpack-${MSGPACK_VERSION}.tar.gz)
file(DOWNLOAD ${MSGPACK_URL} ${CMAKE_CURRENT_SOURCE_DIR}/${MSGPACK_TARBALL}
	INACTIVITY_TIMEOUT 30
	EXPECTED_HASH SHA256=${MSGPACK_SHA256})
execute_process(COMMAND ${CMAKE_COMMAND} -E tar xfz ${MSGPACK_TARBALL}
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
	RESULT_VARIABLE rv)
if(NOT rv EQUAL 0)
  message(FATAL_ERROR "Failed to extract ${MSGPACK_TARBALL}")
endif()

set(LIBRARY_OUTPUT_PATH ${PROJECT_BINARY_DIR})
set(MSGPACK_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/msgpack-c-cpp-${MSGPACK_VERSION}/)
add_subdirectory(${MSGPACK_SOURCE_DIR} EXCLUDE_FROM_ALL)

# Similar enough to FindMsgpack
set(MSGPACK_INCLUDE_DIRS ${MSGPACK_SOURCE_DIR}/include PARENT_SCOPE)
set(MSGPACK_LIBRARIES msgpackc-static PARENT_SCOPE)

=== src/gui/CMakeLists.txt ===
set(QTLIBS Qt${QT_VERSION_MAJOR}::Network Qt${QT_VERSION_MAJOR}::Widgets)

include_directories(.. shellwidget)

if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL 6)
	set(QTLIBS ${QTLIBS} Qt${QT_VERSION_MAJOR}::SvgWidgets)
	qt_add_resources(NEOVIM_RCC_SOURCES data.qrc)
else()
	set(QTLIBS ${QTLIBS} Qt${QT_VERSION_MAJOR}::Svg)
	qt5_add_resources(NEOVIM_RCC_SOURCES data.qrc)
endif()

if(WIN32)
	set(SRCS_PLATFORM
		arguments_qwindowgeometry.cpp
		input_win32.cpp
		printinfo_msgbox.cpp
		)
	if (USE_STATIC_QT)
		add_definitions(-DUSE_STATIC_QT)
		link_directories(${CMAKE_PREFIX_PATH}/share/qt5/plugins/platforms)
		set(QTLIBS ${QTLIBS} Qt${QT_VERSION_MAJOR}PlatformCompositorSupport qwindows)
	endif()
	set(RES_FILE "data.rc")
	enable_language(RC)
elseif(APPLE)
	set(SRCS_PLATFORM
		arguments_qwindowgeometry.cpp
		input_mac.cpp
		printinfo_stdout.cpp
		)
	set(ICON_PATH ${PROJECT_SOURCE_DIR}/third-party/neovim.icns)
	set_source_files_properties(${ICON_PATH} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")

	set(MACOSX_BUNDLE_INFO_PLIST ${PROJECT_SOURCE_DIR}/cmake/MacOSXBundleInfo.plist.in)
else()
	set(SRCS_PLATFORM
		arguments_geometry.cpp
		input_unix.cpp
		printinfo_stdout.cpp
		)
endif()

add_subdirectory(shellwidget)

include(GNUInstallDirs)
set(RUNTIME_PATH )

add_library(neovim-qt-gui
	app.cpp
	contextmenu.cpp
	errorwidget.cpp
	input.cpp
	mainwindow.cpp
	popupmenu.cpp
	popupmenumodel.cpp
	scrollbar.cpp
	shell.cpp
	tabline.cpp
	treeview.cpp
	compat_gui_qt${QT_VERSION_MAJOR}.cpp
	${SRCS_PLATFORM}
	${NEOVIM_RCC_SOURCES})
target_link_libraries(neovim-qt-gui ${QTLIBS} qshellwidget neovim-qt)
target_include_directories(neovim-qt-gui PRIVATE ${CMAKE_SOURCE_DIR}/src/compat/qt${QT_VERSION_MAJOR})

if(APPLE)
	set_property(SOURCE app.cpp PROPERTY COMPILE_DEFINITIONS
		NVIM_QT_RELATIVE_RUNTIME_PATH="../Resources/runtime")
else()
	set_property(SOURCE app.cpp PROPERTY COMPILE_DEFINITIONS
		NVIM_QT_RELATIVE_RUNTIME_PATH="../share/nvim-qt/runtime")
endif()

add_executable(nvim-qt WIN32 MACOSX_BUNDLE main.cpp
	${NEOVIM_RCC_SOURCES}
	${RES_FILE}
	${ICON_PATH})

target_link_libraries(nvim-qt ${QTLIBS} ${MSGPACK_LIBRARIES} neovim-qt-gui)

if(APPLE)
	add_custom_command(TARGET nvim-qt COMMAND ${CMAKE_COMMAND} -E copy_directory
		${CMAKE_CURRENT_SOURCE_DIR}/runtime/
		${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/nvim-qt.app/Contents/Resources/runtime
		COMMENT "Copying runtime into bundle")
#	TODO: Bundle Qt, currently conflicts with brew Qt
#	add_custom_command(TARGET nvim-qt COMMAND macdeployqt
#		ARGS ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/nvim-qt.app
#		COMMENT "Bundling Qt libraries")
endif()

# Link Time Optimization, especially useful for unused auto-generated code.
# On Windows, MinGW may not support LTO.
# See https://github.com/neovim/neovim/pull/8654
if(POLICY CMP0069 AND NOT MINGW)
	cmake_policy(SET CMP0069 NEW)

	include(CheckIPOSupported)
	check_ipo_supported(RESULT IPO_SUPPORTED)
	if(IPO_SUPPORTED AND (NOT CMAKE_BUILD_TYPE MATCHES Debug))
		set_property(TARGET nvim-qt PROPERTY INTERPROCEDURAL_OPTIMIZATION TRUE)
	endif()
endif()

install(TARGETS nvim-qt DESTINATION ${CMAKE_INSTALL_BINDIR})
if(NOT APPLE)
	install(DIRECTORY runtime
		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt/
		PATTERN "README.md" EXCLUDE)
	install(FILES ${PROJECT_SOURCE_DIR}/LICENSE
		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt/)
	install(FILES nvim-qt.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
    install(FILES ${PROJECT_SOURCE_DIR}/third-party/neovim.png
			RENAME nvim-qt.png
			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/192x192/apps/)
    install(FILES ${PROJECT_SOURCE_DIR}/third-party/neovim.svg
			RENAME nvim-qt.svg
			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
endif()

if(WIN32 AND NOT CMAKE_CROSSCOMPILING AND NOT DEFINED USE_STATIC_QT)
	include(WinDeployQt)

	set(__QT_EXCLUDE_DEPLOY_MODULES webkit webkit2)
	if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL 6)
		set(__QT_EXCLUDE_DEPLOY_MODULES )
	endif()

	WinDeployQt(TARGET nvim-qt COMPILER_RUNTIME INCLUDE_MODULES ${QTLIBS} EXCLUDE_MODULES ${__QT_EXCLUDE_DEPLOY_MODULES})
	install(DIRECTORY ${PROJECT_BINARY_DIR}/windeployqt/
		DESTINATION ${CMAKE_INSTALL_BINDIR})
endif()

# Generate help tags
add_custom_command(
	OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc/tags"
	COMMAND ${NEOVIM_EXEC} -i NONE -u NONE -e --headless
	-c "helptags ${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc" -c "quit"
	COMMENT "Generating helptags")

add_custom_target(helptags ALL
	DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/runtime/doc/tags")

=== src/gui/shellwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
if (POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
endif (POLICY CMP0048)
project(qshellwidget)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Qt
set(CMAKE_AUTOMOC ON)
find_package(Qt${QT_VERSION_MAJOR}Widgets REQUIRED)
if(ENABLE_TESTS)
	find_package(Qt${QT_VERSION_MAJOR}Test REQUIRED)
endif()

if (WIN32 AND USE_STATIC_QT)
	add_definitions(-DUSE_STATIC_QT)
endif ()

set(SOURCES
  cell.cpp
  cursor.cpp
  highlight.cpp
  helpers.cpp
  konsole_wcwidth.cpp
  shellcontents.cpp
  shellwidget.cpp
  compat_shellwidget_qt${QT_VERSION_MAJOR}.cpp)

add_library(qshellwidget STATIC ${SOURCES})
target_link_libraries(qshellwidget Qt${QT_VERSION_MAJOR}::Widgets compat)

add_executable(example EXCLUDE_FROM_ALL example.cpp)
target_link_libraries(example qshellwidget )
add_executable(example2 EXCLUDE_FROM_ALL example2.cpp)
target_link_libraries(example2 qshellwidget )
add_executable(example3 EXCLUDE_FROM_ALL example3.cpp)
target_link_libraries(example3 qshellwidget )

add_executable(fontinfo EXCLUDE_FROM_ALL fontinfo.cpp)
target_link_libraries(fontinfo Qt${QT_VERSION_MAJOR}::Widgets )

=== src/gui/shellwidget/test/CMakeLists.txt ===
include_directories(..)

if (WIN32 AND USE_STATIC_QT)
	add_definitions(-DUSE_STATIC_QT)
endif ()

# Define shell2.txt location for bench_paint
file(TO_CMAKE_PATH ${CMAKE_CURRENT_SOURCE_DIR} TEST_SOURCE_DIR)
add_definitions(-DTEST_SOURCE_DIR="${TEST_SOURCE_DIR}")

function(add_xtest SOURCE_NAME)
	add_executable(${SOURCE_NAME} ${SOURCE_NAME}.cpp)
	target_link_libraries(${SOURCE_NAME} Qt${QT_VERSION_MAJOR}::Widgets Qt${QT_VERSION_MAJOR}::Test qshellwidget)
	add_test(NAME ${SOURCE_NAME} COMMAND ${SOURCE_NAME} ${CTEST_EXE_ARGS})
endfunction()

add_xtest(test_cell)
add_xtest(test_shellcontents)
add_xtest(test_shellwidget)
add_xtest(bench_scroll)
add_xtest(bench_cell)
add_xtest(bench_paint)

=== debian/changelog ===
neovim-qt (0.2.18-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:00:37 +1100

neovim-qt (0.2.18-1build1) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 06:02:38 +0000

neovim-qt (0.2.18-1) unstable; urgency=medium

  * New upstream release
  * Explicitly enable testing based on whether nocheck is present

 -- James McCoy <jamessan@debian.org>  Sat, 27 Jan 2024 13:13:42 -0500

neovim-qt (0.2.17-3) unstable; urgency=medium

  * Upload to unstable
  * Remove generated files during clean (Closes: #1045495)
  * Generate API bindings pre-configure to ensure they're available when CMake
    is run.
  * Add explicit python3 Build-Depends

 -- James McCoy <jamessan@debian.org>  Fri, 18 Aug 2023 09:01:45 -0400

neovim-qt (0.2.17-2) experimental; urgency=medium

  * Add fonts-dejavu-core as a test Build-Depends

 -- James McCoy <jamessan@debian.org>  Mon, 20 Mar 2023 14:36:50 -0400

neovim-qt (0.2.17-1) experimental; urgency=medium

  * New upstream release (Closes: #1032556)
  * Remove explicit setting of $HOME since dh_auto_test handles that
  * Build man page in execute_before_dh_auto_install instead of override_dh_auto_build
  * Switch to declarative alternatives
  * Override package-contains-documentation-outside-usr-share-doc for nvim_gui_shim.txt
  * Declare compliance with Policy 4.6.2, no changed needed
  * Bump watch file version to 4
  * Do not install LICENSE file, already part of d/copyright

 -- James McCoy <jamessan@debian.org>  Mon, 20 Mar 2023 11:37:04 -0400

=== debian/control ===
Source: neovim-qt
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
Uploaders:
 Jason Pleau <jason@jpleau.ca>,
 James McCoy <jamessan@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 fonts-dejavu-core <!nocheck>,
 help2man,
 libmsgpack-dev (>= 1.4.0-2),
 libqt5svg5-dev,
 neovim,
 neovim (>= 0.3.2) | xclip,
 ninja-build,
 python3,
 python3-jinja2,
 python3-msgpack,
 qtbase5-dev,
 xauth,
 xvfb,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://github.com/equalsraf/neovim-qt
Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git
Vcs-Browser: https://salsa.debian.org/vim-team/neovim-qt

Package: neovim-qt
Architecture: any
Depends:
 neovim,
 ${misc:Depends},
 ${shlibs:Depends},
Description: neovim client library and GUI
 neovim-qt provides a Qt5 GUI interface for neovim

=== debian/rules ===
#!/usr/bin/make -f

DEB_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

# cmake doesn't honor CPPFLAGS
CFLAGS += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

NVIM_API_LEVEL = $(shell nvim --headless -u NONE -i NONE -c 'echo api_info().version.api_level -cq 2>&1)

ENABLE_TEST = ON
ifneq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	ENABLE_TEST = OFF
endif

export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@ --builddirectory=build --buildsystem=cmake+ninja

override_dh_clean:
	env NVIM_API_LEVEL=$(NVIM_API_LEVEL) dh_clean

override_dh_auto_configure:
	python3 bindings/generate_bindings.py nvim src/auto
	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release -DPYTHON_EXECUTABLE=/usr/bin/python3 -DENABLE_TESTS=$(ENABLE_TEST)

execute_before_dh_auto_install:
# Workaround bug where $DISPLAY is needed for --help
	xvfb-run --auto-servernum help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt

execute_after_dh_auto_install:
	rm -f $(CURDIR)/debian/neovim-qt/usr/share/nvim-qt/LICENSE

override_dh_auto_test:
# Need to use a server with 24bit color depth to avoid libegl-mesa
# crashes on some systems
	xvfb-run --server-args '-screen 0 1024x768x24' --auto-servernum dh_auto_test

=== debian/watch ===
version=4

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/neovim-qt-$1\.tar\.gz/ \
  https://github.com/equalsraf/neovim-qt/tags .*/v?(\d\S*)\.tar\.gz

## neovim-qt 0.2.19

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,7 @@
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
-if (POLICY CMP0069)
-  cmake_policy(SET CMP0069 NEW)
-endif (POLICY CMP0069)
-
+cmake_minimum_required(VERSION 3.9.0)
 # Neovim-Qt Version, used by --version update before release
 # 9999 = Development Pre-Release
-project(neovim-qt VERSION 0.2.18.0)
+project(neovim-qt VERSION 0.2.19.0)
 
 if(NOT EXISTS ${NEOVIM_EXEC})
 	set(NEOVIM_EXEC nvim)
@@ -17,6 +10,7 @@
 set(CMAKE_CXX_STANDARD 11)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
+option(REPRODUCIBLE_BUILD "Make this build reproducible" ON)
 option(USE_GCOV "Enable gcov support" OFF)
 option(ENABLE_CLAZY "Build with KDE Clang Clazy Linter" OFF)
 option(ENABLE_TIDY "Build with Clang Tidy Linter" OFF)

=== src/CMakeLists.txt ===

configure_file(version.h.in ${CMAKE_CURRENT_BINARY_DIR}/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

if(${QT_VERSION_MAJOR} VERSION_GREATER_EQUAL 6.0)
	include_directories(${Qt6SvgWidgets_INCLUDE_DIRS})
	add_definitions(${Qt6SvgWidgets_DEFINITIONS})
endif()

add_subdirectory(compat)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/compat)

set(NEOVIM_QT_SOURCES
  auto/neovimapi0.cpp
  auto/neovimapi1.cpp
  auto/neovimapi2.cpp
  auto/neovimapi3.cpp
  auto/neovimapi4.cpp
  auto/neovimapi5.cpp
  auto/neovimapi6.cpp
  function.cpp
  msgpackiodevice.cpp
  msgpackrequest.cpp
  neovimconnector.cpp
  neovimconnectorhelper.cpp
  util.cpp)

if(WIN32)
  list(APPEND NEOVIM_QT_SOURCES stdinreader.cpp)
endif()

add_library(neovim-qt STATIC ${NEOVIM_QT_SOURCES})
target_link_libraries(neovim-qt Qt${QT_VERSION_MAJOR}::Network ${MSGPACK_LIBRARIES})
target_link_libraries(neovim-qt compat)

add_subdirectory(gui)

=== third-party/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 # This is a minimal CMake project to fetch and build third party
 # dependencies
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
+cmake_minimum_required(VERSION 3.9.0)
 project(neovim-qt-deps)
 
 #

=== src/compat/CMakeLists.txt ===

add_library(compat STATIC compat_qt${QT_VERSION_MAJOR}.cpp)
target_link_libraries(compat Qt${QT_VERSION_MAJOR}::Core)

=== src/gui/CMakeLists.txt ===
--- 
+++ 
@@ -106,17 +106,17 @@
 install(TARGETS nvim-qt DESTINATION ${CMAKE_INSTALL_BINDIR})
 if(NOT APPLE)
 	install(DIRECTORY runtime
-		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt/
+		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt
 		PATTERN "README.md" EXCLUDE)
 	install(FILES ${PROJECT_SOURCE_DIR}/LICENSE
-		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt/)
+		DESTINATION ${CMAKE_INSTALL_DATADIR}/nvim-qt)
 	install(FILES nvim-qt.desktop DESTINATION ${CMAKE_INSTALL_DATADIR}/applications)
     install(FILES ${PROJECT_SOURCE_DIR}/third-party/neovim.png
 			RENAME nvim-qt.png
-			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/192x192/apps/)
+			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/192x192/apps)
     install(FILES ${PROJECT_SOURCE_DIR}/third-party/neovim.svg
 			RENAME nvim-qt.svg
-			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps/)
+			DESTINATION ${CMAKE_INSTALL_DATADIR}/icons/hicolor/scalable/apps)
 endif()
 
 if(WIN32 AND NOT CMAKE_CROSSCOMPILING AND NOT DEFINED USE_STATIC_QT)

=== src/gui/shellwidget/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,4 @@
-cmake_minimum_required(VERSION 2.8.12)
-if (POLICY CMP0048)
-  cmake_policy(SET CMP0048 NEW)
-endif (POLICY CMP0048)
+cmake_minimum_required(VERSION 3.9.0)
 project(qshellwidget)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)

=== debian/changelog ===
neovim-qt (0.2.19-1) unstable; urgency=medium

  * New upstream release
    + Exclude compilation flags from version info by default so the build is
      reproducible. (Closes: #963688)
  * Mark xfvb and xauth Build-Depends <!nocheck>
  * Declare compliance with Policy 4.7.0, no changes needed
  * Remove obsolete xclip Build-Depends
  * Add salsa-ci.yml config

 -- James McCoy <jamessan@debian.org>  Wed, 19 Feb 2025 06:55:54 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: neovim-qt
 Section: editors
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
+Maintainer: Debian Vim Maintainers <team+vim@tracker.debian.org>
 Uploaders:
  Jason Pleau <jason@jpleau.ca>,
  James McCoy <jamessan@debian.org>,
@@ -14,15 +13,14 @@
  libmsgpack-dev (>= 1.4.0-2),
  libqt5svg5-dev,
  neovim,
- neovim (>= 0.3.2) | xclip,
  ninja-build,
  python3,
  python3-jinja2,
  python3-msgpack,
  qtbase5-dev,
- xauth,
- xvfb,
-Standards-Version: 4.6.2
+ xauth <!nocheck>,
+ xvfb <!nocheck>,
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://github.com/equalsraf/neovim-qt
 Vcs-Git: https://salsa.debian.org/vim-team/neovim-qt.git

=== debian/rules ===
--- 
+++ 
@@ -28,8 +28,7 @@
 	dh_auto_configure -- -DUSE_SYSTEM_MSGPACK=ON -DCMAKE_BUILD_TYPE=Release -DPYTHON_EXECUTABLE=/usr/bin/python3 -DENABLE_TESTS=$(ENABLE_TEST)
 
 execute_before_dh_auto_install:
-# Workaround bug where $DISPLAY is needed for --help
-	xvfb-run --auto-servernum help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
+	help2man -s 1 --version-string=$(DEB_VERSION_UPSTREAM)  -n 'Neovim GUI' --no-info -o debian/nvim-qt.1 build/bin/nvim-qt
 
 execute_after_dh_auto_install:
 	rm -f $(CURDIR)/debian/neovim-qt/usr/share/nvim-qt/LICENSE
